# Importeer de python models 'requests' en 'xml.etree' voor het ophalen van informatie van het web en het bewerken van die informatie
import requests
from xml.etree import ElementTree
import RPi.GPIO as GPIO
import time

# Blokje met coniguratie voor de I/O pinnen van de Raspberry Pi
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(17, GPIO.OUT)
GPIO.output(17, GPIO.LOW)

# Vul hier je eigen username en password in...
username = ['hier komt tussen aanhalingstekens je gebruikersnaam van de NS API']
password = ['hier komt tussen aanhalingstekens je wachtwoord van de NS API'

# Een list met een aantal stations, deze lijst kun je makkelijk uitbreiden - of korter maken.
stationsnamen = ['amsterdam+centraal', 'utrecht', 'rotterdam', 'schiphol', 'den+haag']

########################################################################################################

# Maak een eindeloze loop
while True:
    # Probeer het volgende blok code uit te voeren
    try:

        # Aan het begin is de totale vertraging 0 minuten
        totaleVertraging = 0
        storingsTeller = 0
        storingMultiplier = 1

        # De elementen in 'stationsnamen' heten vanaf nu (voor gemak en leesbaarheid) 'station'
        # Doe voor ieder station in de lijst hetvolgende: 
        for station in stationsnamen:
            # Stap 1: haal het xml-bestand waarin voor het betreffende station de treingegevens staan (note to self: de auth kan efficienter geprogrameerd door hem naar boven te halen.)
            r = requests.get('https://webservices.ns.nl/ns-api-avt?station=' + station, auth=(username, password))

            # maak een string met de naam 'root' van het xml-bestand
            root = ElementTree.fromstring(r.text)

            # Print de naam van het station
            print(station)

            # Iedere vertrekkende trein noemen we 'trein', doe voor iedere trein het volgende: 
            for trein in root.findall('VertrekkendeTrein'):

                # Als er bij de trein een XML-tag <Vervoerder> aanwezig is
                if trein.find('Vervoerder') is not None:
                    # Kijk dan of daarin staat 'NS Internationaal'. (Internationale treinen hebben vaak grote vertraging), zoniet, doe dan dit:
                    if trein.find('Vervoerder').text != "NS International":
                        # Als er een XML-tag <VertrekVertragingTekst> is, doe dan:
                        if trein.find('VertrekVertragingTekst') is not None:
                            # maak een string 'vertraging' met de tekst uit de XML-tag <VertrekVertragingTekst> 
                            vertraging = trein.find('VertrekVertragingTekst').text
                            # Knip de '+' van het begin van de string ('+12 min)
                            vertragingInt = vertraging.replace('+', '')
                            # Knip de ' min' van het eind van de string en verander de string in een integer (een getal waarmee je kunt rekenen)
                            vertragingInt = int(vertraging.replace(' min', ''))

                            # Tel de vertraging van de trein op bij het totaal aantal minuten vertaging
                            totaleVertraging = totaleVertraging + vertragingInt

                # Print het huidige totaal aantal minuten vertraging
                print('Totale vertraging = ' + str(totaleVertraging) + ' minuten.')

        ########################################################################################################

        q = requests.get('https://webservices.ns.nl/ns-api-storingen?station=ut', auth=(username, password))

        qroot = ElementTree.fromstring(q.text)

        for storing in qroot.findall('Ongepland'):

            if storing.find('Storing') is not None: # Als er een storing staat aangegeven in <OngeplandeStoring>
                for incident in storing.findall('Storing'):
                    nummer = incident.find('id').text
                    traject = incident.find('Traject').text
                    reden = incident.find('Reden').text
                    bericht = incident.find('Bericht').text
                    print(nummer, ' | ', traject, ' | ', reden)
                    print(bericht)
                    storingsTeller = storingsTeller + 1
                    storingMultiplier = storingMultiplier * 1.2

        ########################################################################################################

        #print('Totale vertraging = ' + str(totaleVertraging) + ' minuten.')
        #print()
        print('Er zijn momenteel', storingsTeller, 'storingen.')
        print('Multiplier:', storingMultiplier)
        print('Totale multiplier vertraging =', int(totaleVertraging * storingMultiplier), 'min.')

        # Als de totale vertraging groter is dan de drempelwaarde (20 minuten in dit geval, dat is een beetje laag, maar het is hndig om te testen)
        if totaleVertraging > 20:
            # Geef dan het alarmsignaal
            GPIO.output(17, GPIO.HIGH)
            print('Vertragingsalarm! Ga niet met de trein!!')
        else: GPIO.output(17, GPIO.LOW)

        time.sleep(5)

    # Als de bovenstaande code (alles onder ' try:') een fout oplevert, probeer dan dit:
    except:
        print('Er is iets fout gegaan bij het ophalen van de data.')
        print(' Het programma probeert hhet over vijf secondenopnieuw.')

        # laat de lamp knipperen
        GPIO.output(17, GPIO.HIGH)
        time.sleep(.5)
        GPIO.output(17, GPIO.LOW)
        time.sleep(.5)
        GPIO.output(17, GPIO.HIGH)
        time.sleep(.5)
        GPIO.output(17, GPIO.LOW)
        time.sleep(.5)
        GPIO.output(17, GPIO.HIGH)
        time.sleep(.5)
        GPIO.output(17, GPIO.LOW)
        time.sleep(.5)
        GPIO.output(17, GPIO.HIGh)
        time.sleep(.5)
        GPIO.output(17, GPIO.LOW)
        time.sleep(1.5)
        
    
